/*
 * Mainboart_UART_functions.c
 *
 * Created: 14.01.2014 10:34:07
 *  Author: Alex
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>

#include "UART_functions.h"
#include <util/delay.h>


 void UART_Init()
 {
	 // baud Calculation: baud = (fosc/ 16*Baudrate)-0.5
	 // baud = (20 MHz / 16*9600)-0.5 = 129.708 --> = baud = 130
	 unsigned int baud = 130;
	 
	 //* Set baud rate */
	 UBRR0H = (unsigned char)(baud>>8);
	 UBRR0L = (unsigned char)baud;
	 /* Enable receiver and transmitter, Set Interrupts: RXCIE - RX-Complete */
	 UCSR0B = (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0);
	 /* Set frame format: 8data, 2stop bit */
	 UCSR0C = (1<<USBS0)|(3<<UCSZ00);
 }
 
uint8_t uart_ReceiveByte( struct circ_buffer *buf )
{
	while ( buffer_is_empty(buf) );	/* wait for incoming data */
	return buffer_read(buf); /* return data */
}


void uart_TransmitByte(struct circ_buffer *buf, uint8_t data )
{
	while ( buffer_is_full(buf) );
	buffer_write(buf,data);		/* store data in buffer */
	
	UCSR0B |= (1<<UDRIE0);			// Enable UDRIE- UART Data Register empty Interrupt - UDRE-ISR is going to put data in UDR
}


