#include "circbuf.h"

void buffer_init (struct circ_buffer *buf)					// Initialization of circular buffer values
{
	buf->read_ptr=0;
	buf->write_ptr=0;
}

void buffer_write(struct circ_buffer *buf, uint8_t byte)	// Write byte into buffer, increment fillcounter and write pointer
{
	cli();
	buf->data[buf->write_ptr] = byte;
	
	if (buf->write_ptr >= buffer_size-1){
		buf->write_ptr = 0;
	}
	else{
		buf->write_ptr = buf->write_ptr + 1;
	}
	sei();
}

uint8_t buffer_read(struct circ_buffer *buf)				// Read byte out of buffer, decrement fillcounter, increment read ptr
{
	cli();
	uint8_t returnval =0;
	
	if  (buf->read_ptr == buf->write_ptr){
		sei();
		return 0;
	}
	else 
	{
		returnval= buf->data[buf->read_ptr];
		
		if (buf->read_ptr >= buffer_size-1){
			buf->read_ptr = 0;
		}
		else{
			buf->read_ptr = buf->read_ptr + 1;
		}
		sei();
		return returnval;
	}

}

uint8_t buffer_is_full (struct circ_buffer *buf)
{
	if (buf->write_ptr + 1 == buf->read_ptr || buf->read_ptr == 0 && buf->write_ptr + 1 == buffer_size)
	return 1;
	else return 0;
}

uint8_t buffer_is_empty (struct circ_buffer *buf)
{
	if (buf->read_ptr == buf->write_ptr) return 1;
	else return 0;
}