#ifndef CIRCBUF_H_
#define CIRCBUF_H_

#include <stdbool.h>
#include <avr/io.h>
#include <stdlib.h>
#include <avr/interrupt.h>


#define buffer_size 16			

struct circ_buffer {
	uint8_t data[buffer_size];
	uint8_t read_ptr;			// points to last input data
	uint8_t write_ptr;			// always points to empty field
	};

void buffer_init (struct circ_buffer *buf);
void buffer_write(struct circ_buffer *buf, uint8_t byte);
uint8_t buffer_read(struct circ_buffer *buf);
uint8_t buffer_is_full (struct circ_buffer *buf);
uint8_t buffer_is_empty (struct circ_buffer *buf);

#endif /*CIRCBUF_H_*/
